﻿using System;

namespace DecoratedTeacher
{
    public class Teacher : IEquatable<ITeacher>, ITeacher
    {
        public String Name { get; set; }
        public int Salary { get; set; }

        public override string ToString()
        {
            return string.Format("name: {0}, Salary: {1}", Name, Salary);
        }

        public bool Equals(ITeacher other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;
            return string.Equals(Name, other.Name);
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            //if (obj.GetType() != this.GetType()) return false;
            ITeacher teacher = obj as ITeacher;
            if (teacher == null) return false;
            return Equals(teacher);
        }

        public override int GetHashCode()
        {
            return (Name != null ? Name.GetHashCode() : 0);
        }
    }
}
