﻿using System;

namespace DecoratedTeacher
{
    public class UnmodifiableTeacher : ITeacher
    {
        private readonly ITeacher _teacher;

        public UnmodifiableTeacher(ITeacher teacher)
        {
            if (teacher == null) throw new ArgumentNullException("teacher");
            _teacher = teacher;
        }

        public string Name
        {
            get { return _teacher.Name; }
            set { throw new NotSupportedException("Name"); }
        }

        public int Salary
        {
            get { return _teacher.Salary; }
            set { throw new NotSupportedException("Salary"); }
        }

        public bool Equals(ITeacher other)
        {
            return _teacher.Equals(other);
        }

        public override bool Equals(Object obj)
        {
            return _teacher.Equals(obj);
        }

        public override int GetHashCode()
        {
            return _teacher.GetHashCode();
        }

        public override string ToString()
        {
            return _teacher.ToString();
        }
    }
}
